#include <stdio.h>	/*Inclusione librerie*/
#include "main.h"

#ifdef DOS	/*In windiws include anche il conio.h*/
#include <conio.h>
#endif

#ifdef LINUX	/*Nel linux include la libreria dei colori*/
#include "tcolor.h"

#define FG CYELLOW
#define BG CBLACK
#endif


/*Ordinamento Sequenziale Selettivo*/

void Ordine(float A[100], int dim) {	/*Prototipo della funzione con definizione parametri*/
   int i,j,pmin,y,k,scelta;	/*Dichiarazioni variabili locali*/
   float sc,x;
#ifdef DOS
   textcolr(14);
   cprintf("\tTipi di ordinamento da scegliere:\n");
   cprintf("\t1 --> Selection Sort\n");
   cprintf("\t2 --> Insertion Sort\n");
   cprintf("\t\t Scelta: \n");
#endif
#ifdef LINUX
iniz_screen(CYELLOW, CBLACK);
   ct_text_xy( &screen_buf, 32, 19, "Tipi di ordinamento da scegliere:", CLR(FG, BG) );
   ct_text_xy( &screen_buf, 21, 20,"1 --> Selection Sort", CLR(FG, BG) );
   ct_text_xy( &screen_buf, 21, 21,"2 --> Insertion Sort", CLR(FG, BG) );
   ct_text_xy( &screen_buf, 21, 22," Scelta: ", CLR(FG, BG) );
   put_vt_cursor(22, 45);
#endif
   do {
   scanf("%d",&scelta);
   }while (scelta<1||scelta>2);
   switch(scelta) {
   case 1:{
   for(i=0;i<=dim-1;i++){	/*for per ordinare gli elementi dell'array*/
	pmin=i;
	for(j=i+1;j<=dim-1;j++){
	     if (A[j]<A[pmin])
		  pmin=j;
	}
   sc=A[pmin];	/*Istruzioni per lo scambio dei valori*/
   A[pmin]=A[i];
   A[i]=sc;
   for(y=0;y<dim;y++){
      printf("%5.3f   ",A[y]);
     }
   printf("\n");
   }
   break;
   }
   case 2:{
   for (j=1;j<=dim-1;j++){
      x=A[j];
      i=j-1;
      while(i>=0 && x<A[i]) {
          A[i+1]=A[i];
          i=i-1;
          }
   A[i+1]=x;
   for(y=0;y<dim;y++){
      printf("%5.3f   ",A[y]);
     }
   printf("\n");
   }   
   break;
   }
   }
}	/*Chiusura funzione*/








