#include <stdio.h>	/*Inclusione librerie*/
#include "main.h"

#ifdef DOS		/*Essendo il conio non utilizzabile in windows essa si disattiva se usata in ambiante linux*/
#include <conio.h>
#endif

#ifdef LINUX		/*In ambiante linux si attiva la libreria dei colori di linux*/
#include "tcolor.h"

#define FG CYELLOW
#define BG CBLACK
#endif

void Ins_lett(int A[], int *N1, int max) {	/*Prototipo della funzione, con dichiarazione parametri*/

   int i,j;	/*Dichiarazione variabili locali*/

#ifdef LINUX
   int error = init_ctio();

   if(error) printf(ctio_error_str(error));
#endif

/*Lettura controllata di A*/
   do {
#ifdef DOS	/*Ambiente windows*/
      printf("Inserisci la dimensione di A: ");
#endif
#ifdef LINUX	/*Ambiente linux*/
      iniz_screen(CYELLOW, CBLACK);
      ct_text_xy( &screen_buf, 10, 7, "Inserisci la dimensione di A: ", CLR(FG, BG) );
      put_vt_cursor(63,7);
#endif
      scanf("%d",N1);	/*LEttura dimensione dell'array*/
   } while((*N1) > max || (*N1) <= 0);

#ifdef LINUX
      iniz_screen(CYELLOW, CBLACK);
#endif


/*Inserimento valori nell'array A*/
   for(i = 0; i < (*N1); i++) {
#ifdef LINUX
      put_vt_cursor(40, 5+i);
      vt_refresh();
#endif		
      printf("\nInserisci il %d valore : ",i+1);
      scanf("%d",&A[i]);
   }
#ifdef LINUX
   uninit_ctio();
#endif

}	/*Chiusura funzione*/
